#!/usr/bin/env python
#-*- coding: ISO-8859-1 -*-
# Author:  Valentin Kuznetsov, 2008
#

# system modules
import os, sys, string, stat, re, types
from exceptions import Exception

def printExcept(msg=""):
    """
       print exception type, value and traceback on stderr
       @type  msg: string
       @param msg: message
       @rtype : none
       @return: none
    """
    if msg:
       print msg
    sys.excepthook(sys.exc_info()[0],sys.exc_info()[1],sys.exc_info()[2])

class FMWSException(Exception):

  def __init__(self, **kwargs):
    """
    Data Discovery exception can be initialized in following ways:
      FMWSException(args=exceptionString)
      FMWSException(exception=exceptionObject)      
    """ 
    args = kwargs.get("args", "")
    ex = kwargs.get("exception", None)
    if ex != None:
      if isinstance(ex, Exception):
         exArgs = "%s" % (ex)
         if args == "":
           args = exArgs
         else:
           args = "%s (%s)" % (args, exArgs)
    Exception.__init__(self, args)

  def getArgs(self):
    """ Return exception arguments. """
    return self.args

  def getErrorMessage(self):
    """ Return exception error. """
    return "%s" % (self.args)

  def getClassName(self):
    """ Return class name. """
    return "%s" % (self.__class__.__name__)

#
# main
#
if __name__ == "__main__":
   ddEx = FMWSException()

